package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.ImageDao;
import com.ekexiu.portal.po.Image;

@Path("/images")
public class ImagesService {
	@Autowrie
	private ImageDao imageDao;
	private Image image;

	public Image getImage() {
		return image;
	}

	public void setImage(Image image) {
		this.image = image;
	}

	public ImageDao getImageDao() {
		return imageDao;
	}

	public void setImageDao(ImageDao imageDao) {
		this.imageDao = imageDao;
	}
	
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, String imageSrc, String resourceId) throws SQLException {
		String imageId = StringUtil.buildUUID();
		image.setImageId(imageId);
		image.setImageSrc(imageSrc);
		image.setResourceId(resourceId);
		this.imageDao.insert(con, image);
		return imageId;
	}
	
	@Get
	@Path("/{imageId}")
	public Image query(@JdbcConn Connection con, @PathVar String imageId) throws SQLException {
		return this.imageDao.query(con, imageId);
	}
	
	@Get
	@Path("/qa")
	public List<Image> queryAll(@JdbcConn Connection con) throws SQLException {
		return this.imageDao.query(con);		
	}
	
	@Get
	@Path("/qares")
	public List<Image> queryRes(@JdbcConn Connection con, String resourceId) throws SQLException {
		return this.imageDao.queryRes(con, resourceId);
	}
	
	@Delete
	@Path("/{imageId}")
	public void deleteId(@JdbcConn(true) Connection con, @PathVar String imageId) throws SQLException {
		this.imageDao.deleteId(con, imageId);
	}
	
	@Delete
	@Path("/src")
	public void deleteSrc(@JdbcConn(true) Connection con, String imageSrc) throws SQLException {
		this.imageDao.deleteSrc(con, imageSrc);
	}
	
	@Delete
	@Path("/del")
	public void deleteRes(@JdbcConn(true) Connection con, String resourceId) throws SQLException {
		this.imageDao.deleteRes(con, resourceId);
	}
}
